﻿/* 
 * Nan.Contests.MvcTriangleContest-2
 * Copyright © 2014 Julio P. Di Egidio <julio@diegidio.name>
 * This program is released into the public domain.
 * No warranty of any kind is implied.
 */

using System;
using System.Collections.Generic;
using System.Numerics;

namespace Nan.Contests.MvcTriangleContest_2
{

	public struct Coord
	{

		private int _row;
		private int _col;

		public int Row { get { return _row; } }
		public int Col { get { return _col; } }

		internal Coord(int row, int col)
		{
			_row = row;
			_col = col;
		}

		public override string ToString()
		{
			return string.Format("({0}; {1})", Row, Col);
		}

	}

	public struct Triangle
	{

		private Coord _center;
		private Coord _left;
		private Coord _right;

		public Coord Center { get { return _center; } }
		public Coord Left { get { return _left; } }
		public Coord Right { get { return _right; } }
		public int Height { get { return _left.Row - _center.Row; } }
		public bool IsDown { get { return _center.Row < _left.Row; } }

		internal Triangle(Coord center, Coord left, Coord right)
		{
			_center = center;
			_left = left;
			_right = right;
		}

		public override string ToString()
		{
			string format;

			if (IsDown)
			{
				format = "{{ C = {0}, L = {1}, R = {2} }}";
			}
			else
			{
				format = "{{ L = {1}, R = {2}, C = {0} }}";
			}

			return string.Format(format, Center, Left, Right);
		}

	}

}
